/*
  */

#include <stdio.h>
#include "pocket.h"

#define CLRSCR "\033[;H\033[2J"
#define CURHOME "\033[;H"

#define LCDX1 (5 * 12)
#define LCDX2 (5 * 16)

#define LCD1 0x7000
#define LCD2 0x703c
#define LCD3 0x7068
#define LCD4 0x707c

#define XMAX 80

#define log2phy(x) ((x) + (x) / 5)

/* ɥ쥹xɸѴ */
#define add2x(a) \
    (((a) < LCD2) ? ((a) - LCD1) : (LCD4 - 1 - (a) + 60))

/* xɸ饢ɥ쥹Ѵ */
#define x2add(x) \
    (((x) < (LCD2 - LCD1)) ? ((x) + LCD1) : (LCD4 - (x) + LCD1 - LCD2))

#define showbyadd(a) {int x; x = add2x(a); showone(log2phy(x), mainram[a]);}

static int a2x[100];
static int x2a[100];

lcdinit()
{
    int x;
    
    /* xɸȥꥢɥ쥹бɽκ */
    for (x = 0; x < LCDX1; x++) {
	x2a[x] = LCD1 + x;
    }
    for (x = LCDX1; x < LCDX2; x++) {
	x2a[x] = LCD3 + (LCDX2 - x - 1);
    }
}

char *sym1[] = {"KANA", "S/K", "SML", "STAT"};
char *sym2[] = {"BUSY", "DEF", "SHIFT", "HYP", "PRO", "RUN", "CAL"};
char *sym3[] = {"E", "M", "()", "RAD", "G", "DE", "PRINT"};
#define SYM1 0x703c
#define SYM2 0x703d
#define SYM3 0x707c

void symdisp()
{
    int i, j;

    j = 1;
    for (i = 0; i < 7; i++) {
	printf("%-5s ", (mainram[SYM2] & j) ? sym2[i] : "");
	j *= 2;
    }
    j = 1;
    for (i = 0; i < 4; i++) {
	printf("%-4s ", (mainram[SYM1] & j) ? sym1[i] : "");
	j *= 2;
    }
    j = 1;
    for (i = 0; i < 3; i++) {
	printf("%-3s ", (mainram[SYM3] & j) ? sym3[i] : "");
	j *= 2;
    }
    printf("%-2s", (mainram[SYM3] & 0x20) ? sym3[5] : "");
    printf("%-1s", (mainram[SYM3] & 0x10) ? sym3[4] : "");
    printf("%-3s ", (mainram[SYM3] & 0x08) ? sym3[3] : "");
    printf("%-5s\r\n", (mainram[SYM3] & 0x40) ? sym3[6] : "");
}


clearall()
{
    printf(CLRSCR);
}


displayall()
{
    int x;
    int b;

    printf(CURHOME);
    symdisp();
    for (b = 1; b < 0x80; b *= 2) {
	for (x = 0; x < XMAX; x++) {
	    if ((mainram[x2a[x]] & b) != 0) {
		putchar('#');
	    }
	    else {
		putchar('.');
	    }
	    if (x % 5 == 4) {
		putchar(' ');
	    }
	}
	putchar('\r');
	putchar('\n');
    }
}

busy()
{
    printf(CURHOME);
    printf("BUSY\r\n");
}




#ifdef MAIN
main()
{
    int x;
    
    lcdinit();
    for (x = 0; x < 80; x++) {
	printf("%04x ", x2a[x]);
	if (x % 5 == 4) {
	    putchar('\n');
	}
    }
}
#endif
